/*
 * Session Caching Daemon
 *
 * Copyright (C) 2008 Juha Railoma <jrma@iki.fi>
 *
 *
 * This file is part of Session Caching Daemon.
 *
 * Session Caching Daemon is free software: you can redistribute
 * it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either
 * version 3 of the License, or (at your option) any later version.
 *
 * Session Caching Daemon is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Session Caching Daemon.  If not, see
 * <http://www.gnu.org/licenses/>.
 *
 *
 * For license terms, see the file COPYING in this directory.
 */

#ifndef _PHP_SCACHE_H_
#define _PHP_SCACHE_H_



#ifdef ZTS
#include "TSRM.h"
#endif

extern zend_module_entry scache_module_entry;



ZEND_BEGIN_MODULE_GLOBALS(scache)
struct sc_conn_t *sc_conn_list;
ZEND_END_MODULE_GLOBALS(scache)

    
#ifdef ZTS
# define SCACHE_G(v) TSRMG(scache_globals_id, zend_scache_globals *, v)
#else
# define SCACHE_G(v) (scache_globals.v)
#endif
    

    
/* init + shutdown */
ZEND_MINIT_FUNCTION(scache);
ZEND_MSHUTDOWN_FUNCTION(scache);
ZEND_RINIT_FUNCTION(scache);
ZEND_RSHUTDOWN_FUNCTION(scache);
ZEND_MINFO_FUNCTION(scache);


/* scache */
ZEND_FUNCTION(scache_open);
ZEND_FUNCTION(scache_popen);
ZEND_FUNCTION(scache_reset);
ZEND_FUNCTION(scache_preset);
ZEND_FUNCTION(scache_connect);
ZEND_FUNCTION(scache_pconnect);
ZEND_FUNCTION(scache_connect_fast);
ZEND_FUNCTION(scache_pconnect_fast);
ZEND_FUNCTION(scache_rename);
ZEND_FUNCTION(scache_drop);

ZEND_FUNCTION(scache_srvstats);
ZEND_FUNCTION(scache_getindex);
ZEND_FUNCTION(scache_iov);

ZEND_FUNCTION(scache_get);
ZEND_FUNCTION(scache_unset);
ZEND_FUNCTION(scache_stat);
ZEND_FUNCTION(scache_exists);
ZEND_FUNCTION(scache_set);
ZEND_FUNCTION(scache_add);
ZEND_FUNCTION(scache_replace);

ZEND_FUNCTION(scache_shget);
ZEND_FUNCTION(scache_shunset);
ZEND_FUNCTION(scache_shstat);
ZEND_FUNCTION(scache_shexists);
ZEND_FUNCTION(scache_shset);
ZEND_FUNCTION(scache_shadd);
ZEND_FUNCTION(scache_shreplace);

ZEND_FUNCTION(scache_cache_put);
ZEND_FUNCTION(scache_cache_get);
ZEND_FUNCTION(scache_cache_unset);

ZEND_FUNCTION(scache_vadd);
ZEND_FUNCTION(scache_vsub);
ZEND_FUNCTION(scache_vget);
ZEND_FUNCTION(scache_vset);
ZEND_FUNCTION(scache_vunset);

ZEND_FUNCTION(scache_ping);
ZEND_FUNCTION(scache_test);


/* local stuff */
#define DEFAULT_MAX_IOV      16



#endif	/* _PHP_SCACHE_H_ */

